
        // Display screen, how big in terms of tiles, add one across for pallet of symbols
		var CANVAS_TILES_ACROSS = 13;
		var CANVAS_TILES_DOWN = 12;
        
        // size of tile in pixels, must be square and must match the tile png image
   		var TILESIZE = 50;

        // size of the HTML5 canvas window in terms of pixels
		var CANVAS_WIDTH = CANVAS_TILES_ACROSS*TILESIZE;
		var CANVAS_HEIGHT = CANVAS_TILES_DOWN*TILESIZE;
        
        // number of tiles across and down in source tile png image
        var NUM_TILES_ACROSS = 13;
		var NUM_TILES_DOWN = 1;
        
        // filename of source image
        var FILENAME = 'tiles.png';
        
        // filename of source php file (the php/html file this is included in)
        var SOURCEFILE = 'editor.php';
        
        // which one of the tiles (0-N) is blank
        var BLANKTILE = 12;
		
        // some mouse button inits
		var BUTTON_LEFT = 0;
		var BUTTON_CENTER = 1;
		var BUTTON_RIGHT = 2;
		
        // various places to keep the screen and tile data
        var _canvas;
		var _screen;
        var _img;
        var _pieces;
        var _tileWidth;
        var _tileHeight;
		
		var _tile;
        var _picked = false;
        
        var wixelFlag = false;
        var appFlag = false;
        var _wixel;
        var _mouse;
        var _stage;
        var _layer;
		var _filecontents;
        
        var _mWixelA;
        var _mWixelS;
        var _mSend = 0;
        var _mPos = 800;
		
		var _pickdrop = 0;

		var Tile = function( x, y ) {
					this.x = x;
					this.y = y;
		};
        
        var Slave = function( a, s ) {
                this.a = a;
                this.s = s;
        };
		
		_mouse = new Array(4);
        
        // Start web sockets code here
        
        ws = new WebSocket("ws://192.168.2.2:8080/ws");

//        ws.onmessage = function (message) {
//            var messages = document.getElementById('messages');
//            messages.innerHTML += "<br>[in] " + message.data;
//        };
        
        sendmsg = function(msg) {
            ws.send(msg);
        };

        function writeMessage(messageLayer, message) {
            var context = messageLayer.getContext();
            messageLayer.clear();
            context.font = "18pt Calibri";
            context.fillStyle = "black";
            context.fillText(message, 10, 325);
        }	

		// read in sprite sheet, create objects to store wixel data
        function init()
        {
		    var i, j;
            _img = new Image();
            _img.addEventListener('load', onImage, false);
            _img.src = FILENAME;
			
			_screen = new Array(CANVAS_TILES_DOWN);
			for (i=0;i<CANVAS_TILES_DOWN;i++)
			    _screen[i] = new Array(CANVAS_TILES_ACROSS);
				
			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
				  _screen[i][j] = BLANKTILE;

            _wixel = new Array(CANVAS_TILES_DOWN);
			for (i=0;i<CANVAS_TILES_DOWN;i++)
			    _wixel[i] = new Array(CANVAS_TILES_ACROSS);
            
            var slave;
			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
                {
                  slave = new Slave(0, 0); 
				  _wixel[i][j] = slave;
                }
                  
            // this is prepared by the php code in the .php file if a load is taking place
			readFileContents();
            
			// pallet on the left hand side, just a list of the main symbols to pick from
			for (i=0;i<CANVAS_TILES_DOWN;i++) 
            {
				_screen[i][CANVAS_TILES_ACROSS-1] = i;
			}
		}

        // this function is called when we want to set the slave and servo numbers for a particular square on the screen, 
        // it just enables the green color of the button and sets the click mode
        function placeWixel()
        {
            if (wixelFlag == false)
            {
                wixelFlag = true;
                document.getElementById("wixel").className='buttongreen';
            }
            else
            {
                wixelFlag = false;
                document.getElementById("wixel").className='button';
            }
        }

        // this will be used to start up the actual touch/send to tornado to rpi to control the slave/servo
        function runApp()
        {
            if (appFlag == false)
            {
                appFlag = true;
                document.getElementById("runapp").className='buttongreen';
            }
            else
            {
                appFlag = false;
                document.getElementById("runapp").className='button';
            }
        }
        
        // this stores the coordinates of the screen, ie what you just created with the symbols so we can load them back later
        // note there is only one file you can load and save, multiple files or naming of the file is not implemented
		function storeCoords(xCoordArray, yCoordArray)
        {
            var r=confirm("Save Layout, are you sure?\nThis will overwrite your current one.");
			if (r != true)
				{
					return;
				}
		
		    var xScreen="";
            var xWixel="";
			var s="";
            var a="";
            var x=""
            var aa=0;
            var ab="";
            var sa=0;
            var sb="";
			
			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++){
				  s = _screen[i][j].toString(16);
				  if (s.length < 2)
				    s = "0" + s;
				  xScreen = xScreen + "0x" + s;
				}
                
			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
                {
				  aa = _wixel[i][j].a;
                  ab = aa.toString(16);
				  if (ab.length < 2)
				      ab = "0" + ab;
                      
				  sa = _wixel[i][j].s;
                  sb = sa.toString(16);
				  if (sb.length < 2)
				      sb = "0" + sb;
				  xWixel = xWixel + "0x" + ab + "0x" + sb;
				}
            
			var request = new XMLHttpRequest();
			request.onreadystatechange = function(){
			}

		request.open("GET","savefile.php?xCoords="+xScreen+xWixel, true);
		request.send();
		}

        // similar to above but clears the screen to all blank tiles
		function clearCoords(xCoordArray, yCoordArray)
        {
            var r=confirm("Clear Layout, are you sure?");
			if (r != true)
				{
					return;
				}
		
		    var xScreen="";
			var s="";

			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
				  _screen[i][j] = BLANKTILE;	// tile number 68 is blank, so use that as fill

			for (i=0;i<CANVAS_TILES_DOWN;i++)
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
                {
				  _wixel[i][j].a = 0;
                  _wixel[i][j].s = 0;
                }
            /*     
			// pallet
			for (i=0;i<CANVAS_TILES_DOWN;i++) {
				_screen[i][CANVAS_TILES_ACROSS-2] = i;
				_screen[i][CANVAS_TILES_ACROSS-1] = i+CANVAS_TILES_DOWN;
			}
			*/
            
			window.location.href=SOURCEFILE;
		}
		
        // function to start the load of the data file that was saved. Page is reloaded and the php creates the string of data
        // from the file on the server (Rpi)
		function loadCoords()
		{
			var r=confirm("Load Stored Layout, are you sure?");
			if (r != true)
				{
					return;
				}
            var sref = SOURCEFILE + "?load=true";
			window.location.href=sref;
		}

        // called after the main tilesheet image loads, set in init() above
        function onImage(e){
            _tileWidth = Math.floor(_img.width / NUM_TILES_ACROSS)	// Fixed because of the size of the sprite sheet
            _tileHeight = Math.floor(_img.height / NUM_TILES_DOWN)
            _screenWidth = _tileWidth * NUM_TILES_ACROSS;
            _screenHeight = _tileHeight * NUM_TILES_DOWN;
            setCanvas();
			initScreen();
			paintScreen();
        }

        // setup the canvas size and add the mouse event handlers
        function setCanvas(){
            _canvas = document.getElementById('canvas');
            _stage = _canvas.getContext('2d');
            _canvas.width = CANVAS_WIDTH;
            _canvas.height = CANVAS_HEIGHT;
            _canvas.style.border = "1px solid black";
			_canvas.addEventListener('mousedown', mousedown, false);
			_canvas.addEventListener('mousemove', mousemove, false);
			_canvas.addEventListener('mouseup',   mouseup, false);
        }
		
        // do this when a mouse button is clicked
		function mousedown(event) {
		    event.preventDefault();
			
			var x = new Number();
			var y = new Number();
			var canvas = document.getElementById("canvas");

			if (event.x != undefined && event.y != undefined)
			{
				x = event.x;
				y = event.y;
			}
			else // Firefox method to get the position
			{
				x = event.clientX + document.body.scrollLeft +
					document.documentElement.scrollLeft;
				y = event.clientY + document.body.scrollTop +
					document.documentElement.scrollTop;
			}

			x -= canvas.offsetLeft;
			y -= canvas.offsetTop;

			x = Math.floor(x/TILESIZE);
			y = Math.floor(y/TILESIZE);
			
			// got the coords, translated to screen cells, now get the mouse button clicked
			
			setmouse(event, x, y, 1);

            // if we are running, we need to do servo action here
            if (appFlag == true)
            {
                // save for mouse up
                _mWixelA = _wixel[y][x].a;
                _mWixelS = _wixel[y][x].s;

                
                if(_mSend == 0)
                {                
                    var msg = "D " + _mWixelA + " " + _mWixelS + " " + _mPos;
                    sendmsg(msg)
                    _mSend = 1;
                    if(_mPos == 800)
                    {
                        _mPos = 2000;
                    }
                    else
                    {
                        _mPos = 800;
                    }
                }
                else
                {
                    _mSend = 0;
                }
                return;
            }
            
            // if the wixel flag is on (button is green) we go here to set the slave/servo
            if (wixelFlag == true)
            {
                var c = _screen[_mouse[1]][_mouse[0]];
                if( c != BLANKTILE )    // if some symbols shouldn't use the wixel, check here
                    setWixelData();
                return;
            }
			
            // are we in the pallet or in the main screen, grab symbol if in pallet, otherwise place it
			if (x >= CANVAS_TILES_ACROSS-1){
				pickScreen();
			}
			else {
				setScreen();
			}
			paintScreen();
		}

		function mouseup(event) {
                //var msg = "U " + _mWixelA + " " + _mWixelS + " " + "2000";
                //sendmsg(msg)
                return;
		}

        // set the wixel data for this tile
        function setWixelData()
        {
            var a = _wixel[_mouse[1]][_mouse[0]].a.toString(10);
            var s = _wixel[_mouse[1]][_mouse[0]].s.toString(10);
            var st = a + "," + s;
            var wixstring = prompt("Enter Wixel Slave and Servo# separated by a comma",st);
            var wixslave = wixstring.split(",");
            
            _wixel[_mouse[1]][_mouse[0]].a = Number(wixslave[0]);
            _wixel[_mouse[1]][_mouse[0]].s = Number(wixslave[1]);
        
        }
		
        // set a picture tile in this screen tile
		function setScreen() {
            if (!_picked) return;
		    if ( _mouse[2] == BUTTON_RIGHT)
				_screen[_mouse[1]][_mouse[0]] = BLANKTILE;
			else
				_screen[_mouse[1]][_mouse[0]] = _tile;
			paintScreen();
		}
		
        // pick up a tile from the pallet
		function pickScreen() {
            _picked = true;
			_tile = _screen[_mouse[1]][_mouse[0]];
		}
		
				
		function setmouse(event, x, y, down) {

			_mouse[0] = x;
			_mouse[1] = y;
			_mouse[3] = down;

		// all browsers except IE before version 9
            if ('which' in event) {
                switch (event.which) {
                case 1:
					_mouse[2] = BUTTON_LEFT;
                    break;
                case 2:
					_mouse[2] = BUTTON_CENTER;
                    break;
                case 3:
					_mouse[2] = BUTTON_RIGHT;
                    break;
                }
            }
            else {
                    // Internet Explorer before version 9
                if ('button' in event) {
                    var buttons = "";
                    if (event.button & 1) {
						_mouse[2] = BUTTON_LEFT;
                    }
                    if (event.button & 2) {
                        if (buttons == "") {
							_mouse[2] = BUTTON_RIGHT;
                        }
                        else {
							_mouse[2] = BUTTON_RIGHT;
                        }
                    }
                    if (event.button & 4) {
                        if (buttons == "") {
							_mouse[2] = BUTTON_CENTER;
                        }
                        else {
							_mouse[2] = BUTTON_CENTER;
                        }
                    }
                }
            }			
		}	
		
		function mousemove() {
		}
		
        function initScreen(){
            _pieces = [];
            _mouse = {x:0,y:0};
            _currentPiece = null;
            _currentDropPiece = null;

			buildRailTiles();
			paintScreen();
        }
		
		function drawBorder() {
			var ctx = canvas.getContext('2d');
			ctx.beginPath();
			ctx.moveTo((CANVAS_TILES_ACROSS-1)*TILESIZE,0);
			ctx.lineTo((CANVAS_TILES_ACROSS-1)*TILESIZE, CANVAS_TILES_DOWN * TILESIZE);
			ctx.lineWidth = 2;
			ctx.strokeStyle = '#cc0000';
			ctx.stroke();
			ctx.moveTo((CANVAS_TILES_ACROSS)*TILESIZE,0);
			ctx.lineTo((CANVAS_TILES_ACROSS)*TILESIZE,CANVAS_TILES_DOWN * TILESIZE);
			ctx.stroke();
			ctx.moveTo((CANVAS_TILES_ACROSS-1)*TILESIZE,0);
			ctx.lineTo((CANVAS_TILES_ACROSS)*TILESIZE,0);
			ctx.stroke();
			ctx.moveTo((CANVAS_TILES_ACROSS-1)*TILESIZE,CANVAS_TILES_DOWN * TILESIZE);
			ctx.lineTo((CANVAS_TILES_ACROSS)*TILESIZE, CANVAS_TILES_DOWN * TILESIZE);
			ctx.stroke();
		}
		
		function paintScreen() {
			for (i=0;i<CANVAS_TILES_DOWN;i++)
			{
				for (j=0;j<CANVAS_TILES_ACROSS;j++)
				{
				  drawRailTile(_screen[i][j], j, i);
				}
			}
			drawBorder();
		}
		
		function drawRailTile( tile, Xpos, Ypos ) {
			var sourceX = _pieces[tile].x;
			var sourceY = _pieces[tile].y;
			var sourceWidth = TILESIZE;
			var sourceHeight = TILESIZE;
			var destWidth = sourceWidth;
			var destHeight = sourceHeight;
			var destX = Xpos * TILESIZE;
			var destY = Ypos * TILESIZE;
			_stage.drawImage(_img, sourceX, sourceY, sourceWidth, sourceHeight, destX, destY, destWidth, destHeight);
		}

		function buildRailTiles() {
			var i;
			var tile;
			var xPos = 0;
			var yPos = 0;
			for (i=0; i < NUM_TILES_ACROSS * NUM_TILES_DOWN;i++){
				var tile = new Tile(xPos, yPos);
				_pieces.push(tile);
                xPos += _tileWidth;
                if(xPos >= _screenWidth){
                    xPos = 0;
                    yPos += _tileHeight;
                }
			}
        }


